/* $Id: main.c,v 1.38 2005/11/10 09:16:38 oohara Exp $ */

#include <stdio.h>
/* rand */
#include <stdlib.h>
/* time */
#include <time.h>

#include "dbnj_util.h"
#include "world.h"
#include "loop.h"

int
main(int argc, char *argv[])
{
  int i;
  const char *ttf_font_name = NULL;
  const char *doc_file_name = NULL;
  int antialias = 0;
  int anija = 0;
  int full_screen = 0;
  world *wp = NULL;

  for (i = 1; i < argc; i++)
  {
    if (argv[i] == NULL)
      continue;

    if (dbnj_string_equal(argv[i], "--font"))
    {
      if (i + 1 < argc)
      {
        ttf_font_name = argv[i + 1];
      }
      else
      {
        fprintf(stderr, "main: missing argument for --font\n");
        return 1;
      }
      i += 1;
    }
    else if (dbnj_string_equal(argv[i], "--doc"))
    {
      if (i + 1 < argc)
      {
        doc_file_name = argv[i + 1];
      }
      else
      {
        fprintf(stderr, "main: missing argument for --doc\n");
        return 1;
      }
      i += 1;
    }
    else if (dbnj_string_equal(argv[i], "--full-screen"))
    {
      full_screen = 1;
    }
    else if (dbnj_string_equal(argv[i], "--anija"))
    {
      anija = 1;
    }
    else if (dbnj_string_equal(argv[i], "--antialias"))
    {
      antialias = 1;
    }
    else
    {
      fprintf(stderr, "main: unknown option: %s\n", argv[i]);
      fprintf(stderr, "usage:\n");
      fprintf(stderr, "%s --doc _document_name_ "
              "--font _ttf_font_file_name_\n", argv[0]);
      fprintf(stderr, " [--full-screen] [--anija] [--antialias]\n");
      return 1;
    }
  }

  if (ttf_font_name == NULL)
  {
    fprintf(stderr, "main: no TrueType font specified\n");
    return 1;
  }

  if (doc_file_name == NULL)
  {
    fprintf(stderr, "main: no document file specified\n");
    return 1;
  }

  srand((unsigned int) time(NULL));

  wp = world_new(ttf_font_name, antialias, anija, full_screen, 1);
  if (wp == NULL)
  {
    fprintf(stderr, "main: world_new failed\n");
    return 1;
  }

  if (game_loop(wp, doc_file_name) == 0)
    game_over_loop(wp);

  world_delete(wp);
  wp = NULL;

  return 0;
}
